/*
** image_effects.h
** 
** Made by Arne Caspari
** Login   <arne@arne-laptop>
** 
** Started on  Wed Feb  7 10:35:43 2007 Arne Caspari
** Last update Wed Feb 14 08:39:18 2007 Arne Caspari
*/

/*
  Copyright (C) 2007  Arne Caspari <arne@unicap-imaging.org>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef   	IMAGE_EFFECTS_H_
# define   	IMAGE_EFFECTS_H_

#include <glib.h>
#include <ucil.h>

#include "ucview.h"

#define COLOR_MAG_COLS 8
#define COLOR_MAG_ROWS 8

struct color_mag_window_data
{
      GtkWidget *window;
      GtkWidget *display;
      unicap_data_buffer_t data_buffer;
      gint *cursor_pos;
      ucil_color_t colors[COLOR_MAG_COLS][COLOR_MAG_ROWS];

      ucil_font_object_t *fobj;

      gint text_w;
      gint text_h;
      gint hspacing;
      gint vspacing;
      
      gint timeout_tag;
};

typedef struct color_mag_window_data color_mag_window_data_t;



void ifx_init( void );
image_effect_data_t *ifx_list_put( GList **list, image_effect_data_t *data );
image_effect_data_t *ifx_list_remove( GList **list, gchar *name );


void ifx_draw_line( unicap_data_buffer_t *buffer, gint *points );
void ifx_draw_measure( unicap_data_buffer_t *buffer, gint *points );
void ifx_update_color_mag( unicap_data_buffer_t *buffer, color_mag_window_data_t *data );


GtkWidget *ifx_create_color_mag_window( GtkWindow *parent, gint cols, gint rows, color_mag_window_data_t *data  );


#endif 	    /* !IMAGE_EFFECTS_H_ */
